package com.prowidesoftware.brilliance.mx2mt;

import com.prowidesoftware.brilliance.constants.Mx2MtConstants;
import com.prowidesoftware.brilliance.exception.SwiftException;
import com.prowidesoftware.brilliance.util.StringUtil;

import java.util.Map;

public abstract class AbstractMx2MtFieldsGenerate implements Mx2MtFieldsGenerate {

    protected Map<String, Object> map = null;

    protected void withMap(Map<String, Object> targetMap) {
        map = targetMap;
    }

    /**
     * length == 8 append AXXX
     * length == 11 substring(0,8)+A+substring(8)
     * @param bicCode
     * @return
     */
    protected String processBicCode(String bicCode) {
        String processedBicCode = "";
        if (!StringUtil.isEmpty(bicCode)) {
            if (bicCode.length() == 8) {
                processedBicCode = bicCode + Mx2MtConstants.BICSUFFIX;
            } else if (bicCode.length() == 11) {
                processedBicCode = bicCode.substring(0, 8) + Mx2MtConstants.BICMIDDLE + bicCode.substring(8);
            } else {
                throw new SwiftException("ERROR", "BicCode length is invalid.");
            }
        }
        return processedBicCode;
    }
}
