package com.prowidesoftware.brilliance.mx2mt.mt900910.impl;

import com.prowidesoftware.brilliance.constants.Mx2MtConstants;
import com.prowidesoftware.brilliance.mx2mt.AbstractMx2MtFieldsGenerate;
import com.prowidesoftware.brilliance.exception.SwiftException;
import com.prowidesoftware.swift.model.mx.MxCamt05400102;
import com.prowidesoftware.swift.model.mx.dic.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * <Ntfctn><Ntry><NtryDtls><TxDtls><Refs><EndToEndId>
 */
public class Field21Generate extends AbstractMx2MtFieldsGenerate {

    private static final Logger logger = LoggerFactory.getLogger(Field21Generate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        logger.info("Field21Generate start.");
        try {
            MxCamt05400102 mxCamt05400102 = (MxCamt05400102)map.get(Mx2MtConstants.MX_OBJECT);
            if (mxCamt05400102 == null || mxCamt05400102.getBkToCstmrDbtCdtNtfctn() == null) {
                return;
            }
            BankToCustomerDebitCreditNotificationV02 bkToCstmrDbtCdtNtfctn = mxCamt05400102.getBkToCstmrDbtCdtNtfctn();
            List<AccountNotification2> ntfctnList = bkToCstmrDbtCdtNtfctn.getNtfctn();
            if (ntfctnList != null && ntfctnList.size() > 0) {
                AccountNotification2 ntfctn = ntfctnList.get(0);
                List<ReportEntry2> ntryList = ntfctn.getNtry();
                if (ntryList != null && ntryList.size() > 0) {
                    ReportEntry2 ntry = ntryList.get(0);
                    List<EntryDetails1> ntryDtlsList = ntry.getNtryDtls();
                    if (ntryDtlsList != null && ntryDtlsList.size() > 0) {
                        EntryDetails1 ntryDtls = ntryDtlsList.get(0);
                        List<EntryTransaction2> txDtlsList = ntryDtls.getTxDtls();
                        if (txDtlsList != null && txDtlsList.size() > 0) {
                            EntryTransaction2 txDtls = txDtlsList.get(0);
                            TransactionReferences2 refs = txDtls.getRefs();
                            if (refs != null) {
                                map.put("field21", refs.getEndToEndId());
                            }
                        }
                    }
                }
            }
        } catch (Exception e) {
            logger.error(e.getMessage());
            throw new SwiftException("ERROR", "Convert MT900/910 Field21 error");
        }
    }
}
