package com.prowidesoftware.brilliance.util;

import com.prowidesoftware.brilliance.constants.ERROR;
import com.prowidesoftware.brilliance.exception.SwiftException;
import org.apache.commons.io.FileUtils;
import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.Velocity;
import org.apache.velocity.app.VelocityEngine;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.StringWriter;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 通过模型类将模板转成字符串
 *
 * **/
public class TemplateUtil {


    /**
     * 通过模型生成函数将模板转成字符串
     * @Param String template 模板名称
     * @Param cache  模板变量Map集合
     * @Param outPut  文件输出保存路径
     * @Param encode  文件生成编码
     * @Return string 返回生成的文件字符串
     * **/
    public static String makeFileByTemplate(String template, Map<String, Object> cache, String outPut, String encode)  {
        String lastStr="";
        ClassLoader classLoader = TemplateUtil.class.getClassLoader();
        URL url = classLoader.getResource("template/");
        if (url != null) {
            VelocityEngine ve = new VelocityEngine();
            try {
                ve.setProperty(VelocityEngine.FILE_RESOURCE_LOADER_PATH, url.toURI().getPath());
                ve.setProperty(Velocity.OUTPUT_ENCODING, encode);
                ve.setProperty(Velocity.INPUT_ENCODING, encode);
                ve.init();
                VelocityContext context = new VelocityContext();
                Template vt = ve.getTemplate(template);
                context.put("vm", cache);
                StringWriter sw = new StringWriter();
                vt.merge(context, sw);
                lastStr=sw.toString();
                if (!StringUtil.isEmpty(outPut)) {
                    FileUtils.write(new File(outPut),lastStr.replaceAll("\\\\\\\\", "\\$"), encode, false);
                }
            } catch (Exception e) {
                throw new SwiftException(ERROR.ERROR_0002,ERROR.ERROR_0002_DESC);
            }
        } else {
        }
        return lastStr;
    }

    public static void makeFileByTemplate2(String template, Map<String, Object> cache, String outPut, String encode) throws IOException {
        ClassLoader classLoader = TemplateUtil.class.getClassLoader();
        URL url = classLoader.getResource("template/");
        if (url != null) {
            VelocityEngine ve = new VelocityEngine();
            ve.setProperty(VelocityEngine.FILE_RESOURCE_LOADER_PATH, url.getPath());
            ve.setProperty(Velocity.OUTPUT_ENCODING, encode);
            ve.setProperty(Velocity.INPUT_ENCODING, encode);
            ve.init();
            VelocityContext context = new VelocityContext();
            Template vt = ve.getTemplate(template);
            for (String key : cache.keySet()) {
                context.put(key, cache.get(key));
            }
            StringWriter sw = new StringWriter();
            vt.merge(context, sw);
            FileUtils.write(new File(outPut), sw.toString().replaceAll("\\\\\\\\", "\\$"), encode, false);
        } else {
            throw new FileNotFoundException("没有在template目录下找到模板文件：" + template);
        }
    }


    public static void main(String[] args) throws Exception {


        Map map = new HashMap();
        List<List> list = new ArrayList<List>();

        List<String> subList = new ArrayList<String>();
        subList.add("aaa");
        subList.add("bbb");
        list.add(subList);

        subList = new ArrayList<String>();
        subList.add("ccc");
        subList.add("ddd");
        subList.add("eee");

        list.add(subList);


        map.put("digestValue", "abc");
        map.put("data", list);
        makeFileByTemplate("singlewindow.vm", map, "d:/test.xml", "utf-8");


    }
}
